typedef int bool;
typedef int resolution;
#define HDFull (0)
#define HDReady  (1)

#define TRUE (1)
#define FALSE (0)



#define PRAGMA_PATH "./Animation";
#define PRAGMA_PATH "./BattleFaces";
#define PRAGMA_PATH "./Faces";
#define PRAGMA_PATH "./Fonts";
#define PRAGMA_PATH "./Maps";
#define PRAGMA_PATH "./Models";
#define PRAGMA_PATH "./Shibuyama";
#define PRAGMA_PATH "./Maps";
#define PRAGMA_PATH "./Panels";
#define PRAGMA_PATH "./shaders";
#define PRAGMA_PATH "./Skies";
#define PRAGMA_PATH "./Sounds";
#define PRAGMA_PATH "./Textures";
#define PRAGMA_PATH "./Title";
#define PRAGMA_PATH "./Savegame";
#define PRAGMA_PATH "./Voices";
///////////////////////////////
#include <acknex.h>
#include <default.c>
#include <strio.c>
#include <StringManipulation.c>

#include <particles.c>
#include <animation02.c>
#include <mtlFX.c>
#include <mtlview.c>
#include <Media.c>
#include <animation01.c>
#include <var.c>
#include <Items.c>
#include <Skills.c>

#include <customSkills.c>
#include <customItems.c>
#include <customEquip.c>




#include <Actors.c>
#include<customEnemies.c>
#include<customEnemySkills.c>
#include<customEnemiesInitalSkills.c>


#include <panels.c>
#include <Walk.c>

#include <Functions.c>
#include <csFunctions.c>

#include<customHeros.c>
#include<customHeroSkills.c>
#include<customHerosInitalSkills.c>




#include <MenuFunctions.c>
#include <dialog.c>
#include <Save.c>
#include <Menu.c>
#include <newCs.c>
#include<customShops.c>
#include<initializecustomShops.c>
#include<giveItemsToShop.c>


#include <initialize.c>

#include <Encounters.c>
//All treasures//
#include <treasures.c>

//All custom Cameras and Cameras wich Events
#include <Events.c>


#include <customCameras.c>
#include <customEntities.c>
#include <customEvents.c>
#include <customNPCs.c>
#include <customTouchEvent.c>
//All custom npcs//
#include <npcs.c>
#include <player.c>
#include <playerAnimation.c>
#include <enemy.c>
#include <customMasterEvent.c>






//All custom Events for a Game//

#define PRAGMA_ZERO
#define SSAO_SAMPLES 5


resolution game_Window = HDFull;

void change_Resolution(resolution a){
	if(a == HDReady){
	title_Panel = title_PanelLow;
	a = HDFull;
	}
	if(a == HDFull){	
	title_Panel.pos_y = -100;
	a = HDReady;
	}
}

///Here are placed all functions which are running during the game.
///The Call for the menu, random enemy encounter, events during a battle and so on...
void loop_Functions(){
	while(1){
		
		//the px_Turn boolean Array represents the status of "player 1/2/3 turn? YES or NO?" 
		//Alway one of them is true - they are not at the same time.
		//All events which take place during a battle have to be placed after the if statement
		if(px_Turn[0] == TRUE || px_Turn[1] == TRUE || px_Turn[2] == TRUE){
			wait(1);
			
			//Every Event during a battle has a specific battleEvent value. Change it before the battle starts.
			if(battleEvents == 1){			
				
				//The counter variable is iterating after every move. If you want that an event take place at turn 3 
				//set	the battleCounter on >= 3.
				if(battleCounter >= 1 && battleAction[0] == FALSE){
					statusEffects(FALSE);
					reset(command_Panel, SHOW | OUTLINE);
					reset(battle_Box, SHOW);
					reset(ks_Pointer, SHOW | OVERLAY );
					deactivateControl = TRUE;
					get_Name("Megumi"); wait_for(get_Name);
					dialogue_Face("megumiFeared.png",245,200,TRUE);
					dialog_On("What is happening here? Who are you?");wait_for(dialog_On);
					get_Name("Shadow"); wait_for(get_Name);
					dialogue_Face("herodarkopenEyes.png",320,200,TRUE);
					dialog_On("It is relentless to hope. I am all and nothing. I am a part of the endless cycle.");wait_for(dialog_On);
					dialogue_Face("megumiFeared.png",245,200,FALSE);
					
					set(battle_Box, SHOW);
					set(ks_Pointer, SHOW | OVERLAY );
					
					battleAction[0] = TRUE;
					deactivateControl = FALSE;
					statusEffects(TRUE);
					wait(-1);
				}
				if(battleCounter >= 3 && battleAction[1] == FALSE){
					deactivateControl = TRUE;
					statusEffects(FALSE);
					reset(command_Panel, SHOW | OUTLINE);
					reset(battle_Box, SHOW);
					reset(ks_Pointer, SHOW | OVERLAY );
					
					//	change_Cam(154,-258,75,120,-14,19);
					
					dialogue_Face("FaceLight.png",320,200,TRUE);
					get_Name("%name%"); wait_for(get_Name);
					dialog_On("Don't touch her!"); wait_for(dialog_On);
					dialogue_Face("herodarkopenEyes.png",320,200,TRUE);
					get_Name("Shadow"); wait_for(get_Name);
					dialog_On("The wish of a person who does not exist. How beautiful.");wait_for(dialog_On);
					dialog_On("Feelings, emotions, love... An illusionary concept of humans.");wait_for(dialog_On);
					
					dialogue_Face("FaceLight.png",320,200,TRUE);
					get_Name("%name%"); wait_for(get_Name);
					dialog_On("I won't repeat myself!"); wait_for(dialog_On);
					dialogue_Face("herodarkopenEyes.png",320,200,TRUE);
					get_Name("Shadow"); wait_for(get_Name);
					dialog_On("No matter how strong your wish of living is, it will end here.");wait_for(dialog_On);
					dialog_On("Every human has to follow my path.");wait_for(dialog_On);
					dialogue_Face("herodarkopenEyes.png",320,200,FALSE);
					
					set(ks_Pointer, SHOW | OVERLAY );
					set(command_Panel, SHOW | OUTLINE);
					set(battle_Box, SHOW);
					wait(1);
					
					
					wait(-1);
					deactivateControl = FALSE;
					battleAction[1] = TRUE;
					statusEffects(TRUE);
				}
				
				if(battleCounter >= 7 && battleAction[2] == FALSE){
					statusEffects(FALSE);
					reset(hp_Bar, SHOW);
					reset(hp_Bar2, SHOW);
					reset(p1_Battle, SHOW);
					reset(p2_Battle, SHOW);

					reset(ks_Pointer, SHOW | OVERLAY );
					reset(command_Panel, SHOW | OUTLINE);
					reset(p1_Battle, SHOW | OUTLINE);
					reset(battle_Box, SHOW);
					
					deactivateControl = TRUE;
					dialogue_Face("FaceLight.png",320,200,TRUE);
					get_Name("%name%"); wait_for(get_Name);
					dialog_On("I won't give up! You have no right to take lives as you want!"); wait_for(dialog_On);
					dialogue_Face("FaceLight.png",320,200,FALSE);
					tint_Screen("HeroNMegumi.png",110,5);
					wait_for(tint_Screen);
					wait(-4);
					dialogue_Face("FaceLight.png",320,200,TRUE);
					get_Name("%name%"); wait_for(get_Name);
					dialog_On("That's Megumi and me."); wait_for(dialog_On);
					dialog_On("I remember everything."); wait_for(dialog_On);
					dialogue_Face("FaceLight.png",320,200,FALSE);
					
					detint_Screen(dummy_Pic,1,100);
					wait_for(detint_Screen);
					wait(-4);
					
					p1_Anima = TRUE;
					status_Sound = snd_play(hakuAnima_Snd,100,0);
					wait(-2);
					status_Sound = snd_play(morph_Sound,100,0);
					
					morph_create(vector(p_Battler[0].x,p_Battler[0].y,p_Battler[0].z));
					wait(-3);
					ent_morph (p_Battler[0] , "HakuWest.mdl");
					wait(-3);
					p1_Anima = FALSE;		
					get_Name("Megumi"); wait_for(get_Name);
					dialogue_Face("megumiShocked.png",245,200,TRUE);
					dialog_On("%name%..."); wait_for(dialog_On);
					dialogue_Face("HeroSmileBitFace.png",245,200,TRUE);
					get_Name("%name%"); wait_for(get_Name);
					dialog_On("I won't let you alone anymore..."); wait_for(dialog_On);
					get_Name("Megumi"); wait_for(get_Name);
					dialogue_Face("megumiTear.png",245,200,TRUE);
					dialog_On("%name% I thought you were dead."); wait_for(dialog_On);
					dialogue_Face("HeroSmileBitFace.png",245,200,TRUE);
					get_Name("%name%"); wait_for(get_Name);
					dialog_On("I doesn't matter if I'm dead or not."); wait_for(dialog_On);
					get_Name("Shadow"); wait_for(get_Name);
					dialogue_Face("herodarkopenEyes.png",320,200,TRUE);
					dialog_On("Fascinating. The part which is called human heart.");wait_for(dialog_On);
					dialogue_Face("HeroAngryFace.png",245,200,TRUE);
					get_Name("%name%"); wait_for(get_Name);
					dialog_On("You are right. It will end here and you will loose this battle!"); wait_for(dialog_On);
					dialogue_Face("HeroAngryFace.png",245,200,FALSE);
					tint_Screen(black_Screen,100,5);
					wait_for(tint_Screen);
					fog_color = 0;
					level_load("credits.wmb");
					detint_Screen(black_Screen,1,100);
					wait_for(detint_Screen);
					set(credits_Panel,SHOW);
					int k = 0;
					while(k < 5400){
						credits_Panel.pos_y-=0.7;
						k += 1;
						wait(1);

					}
					sys_exit(NULL);

					
					
				}
			}


		}

		if(enemyEncounter == TRUE && stepCounter >= randomEncounter){
			if(stepCounter  >= randomEncounter + 15){
				save_Position();
				freeze_Movement = TRUE;
				if(str_cmp(whichEncounter,"Shibuyama") == TRUE) shibuyamaEncounter();
				if(str_cmp(whichEncounter,"Shibuyama01") == TRUE) shibuyamaSecond();
				randomEncounter = random(50)  + 20;
				stepCounter = 0;
			}
			
		}
		



		e1max_HP = Enemy1.max_HP;
		e1cur_HP = Enemy1.cur_HP;
		e1STR = Enemy1.STR;
		e1DEF = Enemy1.DEF;
		e1GST = Enemy1.GST;

		e2max_HP = Enemy2.max_HP;
		e2cur_HP = Enemy2.cur_HP;
		e2STR = Enemy2.STR;
		e2DEF = Enemy2.DEF;
		e2GST = Enemy2.GST;

		e3max_HP = Enemy3.max_HP;
		e3cur_HP = Enemy3.cur_HP;
		e3STR = Enemy3.STR;
		e3DEF = Enemy3.DEF;
		e3GST = Enemy3.GST;
		if(key_l){
			if(debugEnemy == FALSE){			
				set(debug_Enemy01,SHOW);
				set(debug_Enemy02,SHOW);
				set(debug_Enemy03,SHOW);
				debugEnemy = TRUE;
				wait(-0.5);
			}
			else
			{
				reset(debug_Enemy01,SHOW);
				reset(debug_Enemy02,SHOW);
				reset(debug_Enemy03,SHOW);
				debugEnemy = FALSE;
				wait(-0.5);
			}
			
		}
		
		if(key_r){
			
			change_Resolution(game_Window);
			wait(-1);
			
		}
		//Access to the menu
		if (menu_on == FALSE && menu_activated == TRUE) {
			if(key_esc && shop == FALSE){
				menu_Choose();
				wait_for(menu_Choose);			
				wait(-0.3);
			}				
			wait(1);
		}
		//Or leave the menu 	
		else {
			if (menu_on == TRUE && key_esc && shop == FALSE) {
				
				media_play("Cansel.wav",NULL,100);
				hide_Items();
				mouse_map = NULL;
				reset(menu_pan,SHOW);
				reset(menu_Lokalisation,SHOW);
				reset(p1_Panel,SHOW | OUTLINE);

				reset(menu_Time, SHOW);
				menu_on = FALSE;
				reset(menu_Panel, SHOW);
				mouse_mode = 2;
				reset(p1_Status,SHOW | OUTLINE);
				wait(-1.0);
				
				
			}
			wait(1);
		}
		wait(1);
	}
	
}



function game_Begin(){	
	//Starts Ingame Clock
	time();	
		fade_Out(0.01);
	wait_for(fade_Out);
		level_load(starting_Map);
		wait_for(level_load);
	//Rename the first three heros
str_cpy(name_P1,"Haku");
str_cpy(name_P2,"Megumi");
str_cpy(name_P3,"");
	
	//Localisation of the player.
	str_cpy(lokalisation,"Dream");
	
	/*For the save menu
	str_cpy(name01,name_P1);
	str_cpy(name02,name_P2);
	str_cpy(name03,name_P3);
	*/
	//Begin with the parallel running function
	loop_Functions();
	

p2.active = FALSE;
p3.active = FALSE;


	
	//Before the game starts, we give two different starting items.
	item_001.amount = 2;
	item_003.amount = 2;
	
	//fade_In the new music title


	//Environment Settings//
	fog_color = 1;
	camera.fog_start = 400;
	camera.fog_end = 1000;
	
masterIntroEvent();
wait_for(masterIntroEvent);

	



	wait(1);
	
	
}


function main()
{

	// entry: Warning Verbosity (0,1,2,3,4)
	// entry_help: Sets sensitivity of warnings (0 = none, 1 = some, 4 = all).
	warn_level = 0;
	//	screen_size.x = 1280;  screen_size.y = 1024;
	///AUFLOESUNG - FULLSCREEN///	
	//video_window(0,vector(1680,1050,1),2,"Anima");
	video_aspect = 1.777;
	video_mode = 11;
	d3d_antialias = 9;
	
	video_set(1680,1050,0,0);
	video_set(0,0,0,0);
	/////////////////////////////
	



	
	//SPEZIELLE GRAFIKEINSTELLUNGEN////
	d3d_antialias = 12;
	d3d_anisotropy = 9;
	d3d_mipmapping = 4;
	///////////////////////////////////
	camera.clip_near = 40;
	
	reset(e1_Battle, SHOW);
	reset(e2_Battle, SHOW);
	set(title_Panel, SHOW);	
	#ifndef startup_h 

		int i;
		
		//Allocate all Structs	
		for (i = 0; i < 100; i++){ 
			objectID[i] = (object *)malloc(sizeof(object));
			newObjectID[i] = (object *)malloc(sizeof(object));
			equipID[i] = (equip *)malloc(sizeof(equip));
			newEquipID[i] = (equip *)malloc(sizeof(equip));
			skillID[i] = (skills *)malloc(sizeof(skills));
			newSkillID[i] = (skills *)malloc(sizeof(skills));

			
		}
		
		for (i = 0; i < 20; i++){ 
			p1_sList[i] = (skills *)malloc(sizeof(skills));
			p2_sList[i] = (skills *)malloc(sizeof(skills));
			p3_sList[i] = (skills *)malloc(sizeof(skills));
			//fighterList[i] = (skills *)malloc(sizeof(skills));
		}
		
		for (i = 0; i < 20; i++){
			p1_sList[i] = skill_dummy;
			p2_sList[i] = skill_dummy;
			p3_sList[i] = skill_dummy;
		}
		
		for (i = 0; i < 3; i++){
			hero_List[i] = (HERO*)malloc(sizeof(HERO));
			enemy_List[i] = (ENEMY*)malloc(sizeof(ENEMY));
			hero_Battle[i] = (HERO*)malloc(sizeof(HERO));
			enemy_Battle[i] = (ENEMY*)malloc(sizeof(ENEMY));
		}
		

		hr_Battler = (ENTITY*)malloc(sizeof(ENTITY));
		hrPtr = malloc(sizeof(HERO));
		ePtr = malloc(sizeof(ENEMY));
		skillPtr = malloc(sizeof(skills));
		p1_weapon = malloc(sizeof(equip));
		p1_gloves = malloc(sizeof(equip));
		p1_shield = malloc(sizeof(equip));
		p1_armor = malloc(sizeof(equip));
		p1_shoes = malloc(sizeof(equip));
		p1_sth = malloc(sizeof(equip));

		p2_weapon = malloc(sizeof(equip));
		p2_gloves = malloc(sizeof(equip));
		p2_shield = malloc(sizeof(equip));
		p2_armor = malloc(sizeof(equip));
		p2_shoes = malloc(sizeof(equip));
		p2_sth = malloc(sizeof(equip));

		p3_weapon = malloc(sizeof(equip));
		p3_gloves = malloc(sizeof(equip));
		p3_shield = malloc(sizeof(equip));
		p3_armor = malloc(sizeof(equip));
		p3_shoes = malloc(sizeof(equip));
		p3_sth = malloc(sizeof(equip));

		alphabet[0][0] = "A ";
		alphabet[1][0] = "B ";
		alphabet[2][0] = "C ";
		alphabet[3][0] = "D ";
		alphabet[4][0] = "E ";
		alphabet[5][0] = "F ";
		alphabet[6][0] = "G ";
		alphabet[0][1] = "H ";
		alphabet[1][1] = "I ";
		alphabet[2][1] = "J ";
		alphabet[3][1] = "K ";
		alphabet[4][1] = "L ";
		alphabet[5][1] = "M ";
		alphabet[6][1] = "N ";
		alphabet[0][2] = "O ";
		alphabet[1][2] = "P ";
		alphabet[2][2] = "Q ";
		alphabet[3][2] = "R ";
		alphabet[4][2] = "S ";
		alphabet[5][2] = "T ";
		alphabet[6][2] = "U ";
		alphabet[0][3] = "V ";
		alphabet[1][3] = "W ";
		alphabet[2][3] = "X ";
		alphabet[3][3] = "Y ";
		alphabet[4][3] = "Z ";
		alphabet[5][3] = "  ";
		alphabet[6][3] = "  ";
		alphabet[7][0] 	= "a ";
		alphabet[8][0] 	= "b ";
		alphabet[9][0] 	= "c ";
		alphabet[10][0] 	= "d ";
		alphabet[11][0] 	= "e ";
		alphabet[12][0] 	= "f ";
		alphabet[13][0] 	= "g ";
		alphabet[7][1] = "h ";
		alphabet[8][1] = "i ";
		alphabet[9][1] = "j ";
		alphabet[10][1] = "k ";
		alphabet[11][1] = "l ";
		alphabet[12][1] = "m ";
		alphabet[13][1] = "n ";
		alphabet[7][2] = "o ";
		alphabet[8][2] = "p ";
		alphabet[9][2] = "q ";
		alphabet[10][2] = "r ";
		alphabet[11][2] = "s ";
		alphabet[12][2] = "t ";
		alphabet[13][2] = "u ";
		alphabet[7][3] = "v ";
		alphabet[8][3] = "w ";
		alphabet[9][3] = "x ";
		alphabet[10][3] = "y ";
		alphabet[11][3] = "z ";
		alphabet[12][3] = "  ";
		alphabet[13][3] = "  ";

		///TITLE SCREEN//
		if(str_cmpi(which_titlescreen,"3d") == 1){
			
			level_load(titleScreen_Map);
			change_Cam(-407.980 ,-34.503 ,106.425 ,-10.194 ,-5.297 ,-12.196 );
			my_sky = ent_createlayer("Nacht+6.tga", SKY | CUBE | VISIBLE, 0);
			fog_color = 1;
		}
		else
		{
			Title_Screen_Panel->bmap = bmap_create(titleScreen_Map);
			set(Title_Screen_Panel,SHOW);
			
		}
	#endif
	fps_max = 60;
	activatePanelArray();
	wait_for(activatePanelArray);
	activateItems();
	wait_for(activateItems);
	initialize_Class();
	wait_for(initialize_Class);
	
initialize_customHero();
learn_SpellsForCustomHeros();
initialize_customEnemy();
learn_SpellsForCustomEnemies();
init_customShops();
giveItemsShop();
	play_Music(title_Music,80);

	while(titleScreen == TRUE){

		
		
		set(menu_Pointer,SHOW);

		while(titleZeiger == 1){
			menu_Pointer.pos_x = 20;
			menu_Pointer.pos_y = 850;
			
			if (key_cud){
				status_Sound = snd_play(cursor_Move,100,0);
				titleZeiger = 2;
				menu_Pointer.pos_x = 20;
				menu_Pointer.pos_y = 900;
				wait(-0.5);
			}
			
			if (key_cuu){
				status_Sound = snd_play(cursor_Move,100,0);
				titleZeiger = 4;
				menu_Pointer.pos_x = 20;
				menu_Pointer.pos_y = 1000;
				wait(-0.5);
			}

			if(key_enter){
				snd_stop(music_Handle);
				media_play("Choice.wav",NULL,100);
				//set(loading_Screen, SHOW);
				wait(2);

				
				reset(menu_Pointer,SHOW);	
				
				reset(title_Panel, SHOW);
				
				
				fog_color = 0;









				game_Begin();
				reset(Title_Screen_Panel,SHOW);
				titleScreen = FALSE;
				
				
				break;
			}

			wait(1);	
		}






		while(titleZeiger == 2){
			
			
			if (key_cud){
				status_Sound = snd_play(cursor_Move,100,0);
				titleZeiger = 3;
				menu_Pointer.pos_x = 20;
				menu_Pointer.pos_y = 950;
				wait(-0.5);
			}
			
			if (key_cuu){
				status_Sound = snd_play(cursor_Move,100,0);
				titleZeiger = 1;
				menu_Pointer.pos_x = 20;
				menu_Pointer.pos_y = 850;
				wait(-0.5);
			}
			


			wait(1);	
		}

		while(titleZeiger == 3){
			
			
			if (key_cud){
				status_Sound = snd_play(cursor_Move,100,0);
				titleZeiger = 4;
				menu_Pointer.pos_x = 20;
				menu_Pointer.pos_y = 1000;
				wait(-0.5);
			}
			
			if (key_cuu){
				status_Sound = snd_play(cursor_Move,100,0);
				titleZeiger = 2;
				menu_Pointer.pos_x = 20;
				menu_Pointer.pos_y = 900;
				
				wait(-0.5);
			}
			
			if (key_enter){
				change_Resolution(game_Window);
				wait(-1);
			}
			
			
			wait(1);	
		}


		while(titleZeiger == 4){
			
			
			if (key_cud){
				status_Sound = snd_play(cursor_Move,100,0);
				titleZeiger = 1;
				menu_Pointer.pos_x = 20;
				menu_Pointer.pos_y = 850;
				wait(-0.5);
			}
			
			if (key_cuu){
				status_Sound = snd_play(cursor_Move,100,0);
				titleZeiger = 3;
				menu_Pointer.pos_x = 20;
				menu_Pointer.pos_y = 950;
				wait(-0.5);
			}

			wait(1);	
		}

		wait(1);	
	}

}

