typedef struct {
	STRING* name;
	STRING* info;
	var hp_Effect;
	var physical_Effect;
	var fire_Effect;
	var water_Effect;
	var wind_Effect;
	var earth_Effect;
	var mp_Consume;
	var lvl;
	
	bool FIRE;
	bool WATER;
	bool WIND;
	bool EARTH;
	
	bool whiteMagic;
	bool blackMagic;
	bool active;
	bool antidote;
	bool awakemaker;
	bool desilent;
	bool eyedrop; 
	bool lifemaker;
	bool partycast;
	bool enabled;
	var animation;  
} skills;


typedef struct{
	
	skills* skillActive;

} skillsPlayer;


skills *p1_sList[20];
skills *p2_sList[20];
skills *p3_sList[20];

skills *skillID[100];
skills *newSkillID[100];

//////////////////////////////
// Prepared slots for skills
//////////////////////////////
skills* skill_dummy = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;

	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_001 = {
	 name 			= "Media";
	 info 			= "Healing spell with low effect.(2 MP)";
	 hp_Effect 		= 20;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 2;

	 WATER			= TRUE;
	 whiteMagic		= TRUE;
	 blackMagic		= FALSE;
	 active			= TRUE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
	 
	 animation		= 1;
}

skills* skill_002 = {
	 name 			= "Pyr";
	 info 			= "Slight firedamage on one enemy.(2 MP)";
	 hp_Effect 		= 30;
	 fire_Effect 	= 50;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 2;
		
	 FIRE 			= FALSE;
	 WATER			= FALSE;
	 WIND				= FALSE;
	 EARTH 			= FALSE;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= TRUE;
	 active			= TRUE;
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
	 enabled			= FALSE;
	 animation		= 2;
}

skills* skill_003 = {
	 name 			= "Ago";
	 info 			= "Slight waterdamage on one enemy.(2 MP)";
	 hp_Effect 		= 40;
	 fire_Effect 	= 0;
	 water_Effect 	= 60;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 2;
	 
	 FIRE 			= FALSE;
	 WATER			= FALSE;
	 WIND				= FALSE;
	 EARTH 			= FALSE;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= TRUE;
	 active			= TRUE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
	 
	 animation		= 3;
}

skills* skill_004 = {
	 name 			= "Rabu";
	 info 			= "Slight winddamage on one enemy.(5 MP)";
	 hp_Effect 		= 20;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 50;
	 earth_Effect 	= 0;
	 mp_Consume 	= 5;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= TRUE;
	 active			= TRUE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
	 
	 animation		= 4;
}

skills* skill_005 = {
	 name 			= "Tebo";
	 info 			= "Slight earthdamage on one enemy.(5 MP)";
	 hp_Effect 		= 20;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 50;
	 mp_Consume 	= 5;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= TRUE;
	 active			= TRUE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
	 
	 animation		= 4;
}

skills* skill_006 = {
	 name 			= "Posona";
	 info 			= "Cures the status effect 'Poison'.(5 MP)";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 5;
	 
	 WATER			= TRUE;
	 whiteMagic		= TRUE;
	 blackMagic		= FALSE;
	 active			= TRUE;	
	 antidote 		= TRUE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_007 = {
	 name 			= "Depaca";
	 info 			= "Cures the status effect 'Blind'.(5 MP)";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 5;
	 
	 WATER			= TRUE;
	 whiteMagic		= TRUE;
	 blackMagic		= FALSE;
	 active			= TRUE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= TRUE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_008 = {
	 name 			= "Yumon";
	 info 			= "Cures the status effect 'Sleep'. (5 MP)";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 5;
	 
	 whiteMagic		= TRUE;
	 blackMagic		= FALSE;
	 active			= TRUE;	
	 antidote 		= FALSE;
	 awakemaker		= TRUE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_009 = {
	 name 			= "Ilumas";
	 info 			= "Increases 1 Point of a party members 'Mind'. (5 MP)";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 1;
	 earth_Effect 	= 0;
	 mp_Consume 	= 5;
	 
	 WIND				= TRUE;
	 whiteMagic		= TRUE;
	 blackMagic		= FALSE;
	 active			= TRUE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_010 = {
	 name 			= "Rabyn";
	 info 			= "Increases 1 Point of a party members 'Defense'. (5 MP)";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 1;
	 mp_Consume 	= 5;
	
	 EARTH			= TRUE;
	 whiteMagic		= TRUE;
	 blackMagic		= FALSE;
	 active			= TRUE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_011 = {
	 name 			= "Pyros";
	 info 			= "Increases 1 Point of a party members 'Strength'. (5 MP)";
	 hp_Effect 		= 0;
	 fire_Effect 	= 1;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 5;
	 
	 FIRE				= TRUE;
	 whiteMagic		= TRUE;
	 blackMagic		= FALSE;
	 active			= TRUE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
	 animation 		= 2;
}

skills* skill_012 = {
	 name 			= "Pyragaz";
	 info 			= "Decreases 1 Point of an enemies 'Strenght'. (5 MP)";
	 hp_Effect 		= 0;
	 fire_Effect 	= 1;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 FIRE				= TRUE;
	 whiteMagic		= FALSE;
	 blackMagic		= TRUE;
	 active			= TRUE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_013 = {
	 name 			= "Rabagaz";
	 info 			= "Decreases 1 Point of an enemies 'Mind'. (5 MP)";
	 hp_Effect 		= 0;
	 fire_Effect 	= 5;
	 water_Effect 	= 0;
	 wind_Effect 	= 1;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;

	 WIND				= TRUE;
	 whiteMagic		= FALSE;
	 blackMagic		= TRUE;
	 active			= TRUE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_014 = {
	 name 			= "Tebogo";
	 info 			= "Decreases 1 Point of an enemies 'Defense'. (5 MP)";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 1;
	 mp_Consume 	= 0;
	 
	 EARTH			= TRUE;
	 whiteMagic		= FALSE;
	 blackMagic		= TRUE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_015 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_016 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}


skills* skill_017 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_018 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_019 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_020 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_021 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_022 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_023 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_024 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_025 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_026 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_027 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_028 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_029 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_030 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_031 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_032 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_033 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_034 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_035 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_036 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_037 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_038 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_039 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_040 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_041 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_042 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_043 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_044 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_045 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_046 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_047 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_048 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_049 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}

skills* skill_050 = {
	 name 			= "";
	 info 			= "";
	 hp_Effect 		= 0;
	 fire_Effect 	= 0;
	 water_Effect 	= 0;
	 wind_Effect 	= 0;
	 earth_Effect 	= 0;
	 mp_Consume 	= 0;
	 
	 whiteMagic		= FALSE;
	 blackMagic		= FALSE;
	 active			= FALSE;	
	 antidote 		= FALSE;
	 awakemaker		= FALSE;
	 desilent		= FALSE;
	 eyedrop			= FALSE; 
	 lifemaker		= FALSE;
	 partycast		= FALSE;
}
skills *skillPtr = *skill_002;