






//Standard Model: marine.mdl
//Variable1: Shadow
//Variable2: EdgeWidth
//Variable3: Threshold
//Variable4: Smooth
var pMoving = 6;
var pRunning = 12;
float PMovAni = 0.9;
float PRunAni = 0.4;
void play_Gift(){
	status_Sound = snd_play(gift, 50, 0);
	set(gift_Screen,SHOW);
	wait(-0.2);
	reset(gift_Screen,SHOW);
	wait(1);
}



action player1()

{

	var movement_speed = 7; // movement speed

	player = my; // I'm the player


	VECTOR temp;

	while (1)

	{

		player.pan -= 7 * mouse_force.x * time_step;

		camera.x = player.x;

		camera.y = player.y;

		camera.z = player.z + 50 + 1.1 * sin(my.skill44); // play with 50 and 1.1

		camera.pan = player.pan;

		camera.tilt += 5 * mouse_force.y * time_step;

		vec_set (temp.x, my.x); // trace 10,000 quants below the player

		temp.z -= 10000;

		temp.z = -c_trace (my.x, temp.x, IGNORE_ME | IGNORE_PASSABLE | USE_BOX);

		temp.x = movement_speed * (key_w - key_s) * time_step; // WSAD to move

		temp.y = movement_speed * (key_a - key_d) * 0.6 * time_step;

		c_move (my, temp.x, nullvector, IGNORE_PASSABLE | GLIDE);

		wait (1);

	}

}


action player_walk()
{ 
	mtl_setup(0,30,0,1);
	player = me;
	my.emask = ENABLE_PUSH;

	my.group = 2;
	//vec_scale(my.scale_x,1.2); // scale entity to small size
	c_setminmax(me); 
	// if necessary, adjust the bounding box to give the entity 'floor room' (see remarks) 
	// my.min_z *= 0.5;

	var speed_down = 0;   // downward speed by gravity
	var anim_percent = 0; // animation percentage
	VECTOR vFeet;
	vec_for_min(vFeet,me); // vFeet.z = distance from player origin to lowest vertex


	while (1)
	{
		
		while (freeze_Movement == TRUE){wait(1);}
		// rotate the player using the [A] and [D] keys      
		

		// determine the ground distance by a downwards trace
		var dist_down; 
		
		if (c_trace(my.x,vector(my.x,my.y,my.z-5000), IGNORE_ME | IGNORE_PASSABLE | USE_BOX) > 0)
		dist_down = my.z + vFeet.z - target.z; // get distance between player's feet and the ground
		else
		dist_down = 0;

		// apply gravity when the player is in the air

		if (dist_down > 0)  // above floor, fall down with increasing speed
		dist_down = clamp(dist_down,0,accelerate(speed_down,5,0.1));

		else                // on or below floor, set downward speed to zero
		speed_down = 0;


		// move the player using the [W] and [S] keys      
		var dist_ahead = pMoving*(key_w-key_s)*time_step;
		dist_ahead = sign(dist_ahead)*(abs(dist_ahead) + 0.3*dist_down); // adapt the speed on slopes
		c_move(me,vector(dist_ahead,0,0),vector(0,0,-dist_down),IGNORE_PASSABLE | GLIDE | IGNORE_PUSH); // move the player
		
		
		var dist_ahea = pRunning*(key_shift && key_w-key_s)*time_step;
		dist_ahea = sign(dist_ahea)*(abs(dist_ahea) + 0.3*dist_down); // adapt the speed on slopes
		c_move(me,vector(dist_ahea,0,0),vector(0,0,-dist_down),IGNORE_PASSABLE | GLIDE | IGNORE_PUSH); // move the player
		// animate the player according to its moved distance
		while (key_a || key_d) {
			my.pan += 10*(key_a-key_d)*time_step; 
			anim_percent += 10*(key_a-key_d)*time_step; // 1.3 = walk cycle percentage per quant
			ent_animate(me,"walk",anim_percent,ANM_CYCLE); // play the "walk" animation	
			wait(1);
		}

		var randomEncounterCounter = 0;

		if (dist_ahead != 0) // player is moving ahead
		{
			stepCounter += 0.2*time_step;
			if(stepCounter == 99) stepCounter = 0;
			if (p1.poison == TRUE){
				giftzaehler += 1*time_step;
				if (giftzaehler > 30 && p1.cur_HP > p1.max_HP/100*2) {
					//	
					play_Gift();
					p1.cur_HP -= p1.max_HP/100*2;
					giftzaehler = 0;
					
				}	
			}
			if (p2.poison == TRUE && p2.active == TRUE && p2.weak == FALSE){
				giftzaehler2 += 1*time_step;
				if (giftzaehler2 > 30 && p2.cur_HP > p2.max_HP/100*2) {
					//	
					play_Gift();
					p2.cur_HP -= p2.max_HP/100*2;
					giftzaehler2 = 0;
					
				}	
			}
			if (p3.poison == TRUE && p3.active == TRUE && p3.weak == FALSE){
				giftzaehler3 += 1*time_step;
				if (giftzaehler3 > 30 && p3.cur_HP > p3.max_HP/100*2) {
					//	
					play_Gift();
					p3.cur_HP -= p3.max_HP/100*2;
					giftzaehler3 = 0;
					
				}	
			}
			
			
			
			
			anim_percent += PMovAni*dist_ahead; // 1.3 = walk cycle percentage per quant
			ent_animate(me,"walk",anim_percent,ANM_CYCLE); // play the "walk" animation
			c_updatehull(my,10);
			
		}
		
		else if (dist_ahead == 0) // player stands still
		{ 
			c_updatehull(my,10);
			anim_percent += 3*time_step; 
			//ent_animate(me,"standB",anim_percent,ANM_CYCLE); // play the "stand" animation
			ent_animate(me,"idle",anim_percent,ANM_CYCLE); // play the "stand" animation
		}
		if (dist_ahea != 0) // player is moving ahead
		{
			c_updatehull(my,10);	
			anim_percent += PRunAni*dist_ahead; // 1.3 = walk cycle percentage per quant
			ent_animate(me,"run",anim_percent,ANM_CYCLE); // play the "walk" animation
		}
		
		
		wait(1);
	}
}


VECTOR p1_Vector;




action player_Battle()
{ 
	int i;
	c_setminmax(me); 
	//my.emask = ENABLE_PUSH;
		my.lightrange = 250; 
	// my.group = 2;
	p_Battler[0] = me;  
	mtl_setup(0,1,0,0);

	ent_morph (my, p1.playermodel);
	//vec_scale(my.scale_x,33); // scale entity to small size
	// if necessary, adjust the bounding box to give the entity 'floor room' (see remarks) 
	// my.min_z *= 0.5;

	var speed_down = 0;   // downward speed by gravity
	var anim_percent = 0; // animation percentage
	VECTOR vFeet;
	vec_for_min(vFeet,me); // vFeet.z = distance from player origin to lowest vertex

while(1){
	while (p1_dead == FALSE){



		while(p1_Defend == FALSE && p1_Attack == FALSE && p1_Run == FALSE && p1_Back == FALSE && p1_Item == FALSE && p1_Damaged == FALSE && p1_Anima == FALSE)     { 
			anim_percent += 6*time_step;//03 
			//ent_animate(p_Battler[0],"StandB",anim_percent,ANM_CYCLE); // play the "stand" animation
			ent_animate(p_Battler[0],p1_fightIdle,anim_percent,ANM_CYCLE); 
			wait(1);
			if(p1_dead == TRUE) break;
		}
		anim_percent = 0;
		while (p1_Run == TRUE){
			
			anim_percent += 5*time_step; 
			//ent_animate(p_Battler[0],"walkA",anim_percent,ANM_CYCLE); // play the "stand" animation
			ent_animate(p_Battler[0],p1_fightRun,anim_percent,ANM_CYCLE); // play the "stand" animation
			
			wait(1);     
		}
		anim_percent = 0;
		while (p1_Back == TRUE){
			
			anim_percent += 5*time_step; 
			//ent_animate(p_Battler[0],"walkA",anim_percent,ANM_CYCLE); // play the "stand" animation
			ent_animate(p_Battler[0],p1_fightBack,anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);     
		}
		anim_percent = 0;
		while (p1_Attack == TRUE){
			
			anim_percent += 3*time_step; 
			//ent_animate(p_Battler[0],"slashL",anim_percent,ANM_CYCLE); // play the "stand" animation
			ent_animate(p_Battler[0],p1_fightAttack,anim_percent,0); // play the "stand" animation
			wait(1);     
		}
		while (p1_Defend == TRUE){
			
			anim_percent += 4*time_step;
			//ent_animate(p_Battler[0],"parryA 4",anim_percent,ANM_CYCLE); // play the "stand" animation
			ent_animate(p_Battler[0],p1_fightDefense,anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);
			
		}

		while(p1_Item == TRUE){
			anim_percent += 4*time_step;//3 
			ent_animate(p_Battler[0],p1_fightItem,anim_percent,0); // play the "stand" animation
			wait(1);	
		}

		while(p1_Damaged == TRUE){
			while(anim_percent < 100){
				anim_percent += 4*time_step;//3 
				ent_animate(p_Battler[0],p1_fightDamaged,anim_percent,0); // play the "stand" animation
				wait(1);	
			}
			anim_percent= 100;
			
			while (anim_percent> 0){
				
				anim_percent -= 4*time_step; 
				//ent_animate(p_Battler[0],"walkA",anim_percent,ANM_CYCLE); // play the "stand" animation
				ent_animate(p_Battler[0],p1_fightDamaged,anim_percent,0); // play the "stand" animation
				

				wait(1);     
			}
		}

		while(p1_Anima == TRUE){
			anim_percent += 1*time_step; 
			ent_animate(p_Battler[0],p1_fightAnima,anim_percent,0); // play the "stand" animation
			wait(1);	
		}
		
	
		while(p1_dead == TRUE){
			anim_percent += 2*time_step; 
			
			ent_animate(p_Battler[0],p1_fightDead,anim_percent,0); 
			wait(1);
			
			if(p1.weak == FALSE){
				anim_percent = 100;
				
				while(anim_percent> 0){

					anim_percent -= 2*time_step; 
					
					ent_animate(p_Battler[0],p1_fightDead,anim_percent,0); 
					wait(1);
				}
				
				p1_dead = FALSE;
				p1.weak = FALSE;
				break;
			}
			wait(1);
		}
		
	}
wait(1);
}
	
}





action player_Battle02()
{ 
	my.emask = ENABLE_PUSH;

	my.group = 2;
	c_setminmax(me); 
	p_Battler[1] = me;  
	mtl_setup(0,1,0,0);
	ent_morph (my, p2.playermodel);

	// if necessary, adjust the bounding box to give the entity 'floor room' (see remarks) 
	// my.min_z *= 0.5;

	if(p2.active == FALSE) set(me,INVISIBLE);
	var speed_down = 0;   // downward speed by gravity
	var anim_percent = 0; // animation percentage
	VECTOR vFeet;
	vec_for_min(vFeet,me); // vFeet.z = distance from player origin to lowest vertex
while(1){


	while (p2_dead == FALSE){
wait(1);
		while(p2_Defend == FALSE && p2_Attack == FALSE && p2_Run == FALSE && p2_Item == FALSE && p2_Damaged == FALSE && p2_Anima == FALSE)     { 
			anim_percent += 6*time_step; 
			ent_animate(p_Battler[1],p2_fightIdle,anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);
			if(p2_dead == TRUE) break;
		}
		anim_percent = 0;
		while (p2_Run == TRUE){
			
			anim_percent += 5*time_step; 
			ent_animate(p_Battler[1],p2_fightRun,anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);     
		}
		anim_percent = 0;
		while (p2_Attack == TRUE){
			
			anim_percent += 3*time_step; 
			ent_animate(p_Battler[1],p2_fightAttack,anim_percent,0); // play the "stand" animation
			wait(1);     
		}
		while (p2_Defend == TRUE){
			
			anim_percent += 3*time_step; 
			ent_animate(p_Battler[1],p2_fightDefense,anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);
			
		}

		while(p2_Item == TRUE){
			anim_percent += 3*time_step; 
			ent_animate(p_Battler[1],p2_fightItem,anim_percent,0); // play the "stand" animation
			wait(1);	
		}



		while(p2_Damaged == TRUE){
			while(anim_percent < 100){
				anim_percent += 4*time_step;//3 
				ent_animate(p_Battler[1],p2_fightDamaged,anim_percent,0); // play the "stand" animation
				wait(1);	
			}
			anim_percent= 100;
			
			while (anim_percent> 0){
				
				anim_percent -= 4*time_step; 
				//ent_animate(p_Battler[0],"walkA",anim_percent,ANM_CYCLE); // play the "stand" animation
				ent_animate(p_Battler[1],p2_fightDamaged,anim_percent,0); // play the "stand" animation
				
				
				wait(1);     
			}
		}


		while(p2_Anima == TRUE){
			anim_percent += 2*time_step; 
			ent_animate(p_Battler[1],p2_fightAnima,anim_percent,0); // play the "stand" animation
			wait(1);	
		}



		

		while(p2_dead == TRUE){
			anim_percent += 2*time_step; 
			
			ent_animate(p_Battler[1],p2_fightDead,anim_percent,0); 
			wait(1);
			
			if(p2.weak == FALSE){
				anim_percent = 100;
				
				while(anim_percent> 0){

					anim_percent -= 2*time_step; 
					
					ent_animate(p_Battler[1],p2_fightDead,anim_percent,0); 
					wait(1);
				}
				
				p2_dead = FALSE;
				p2.weak = FALSE;
				break;
			}
			wait(1);
		}
		
	}
wait(1);
}
	
}

action player_Battle03()
{ 
	my.emask = ENABLE_PUSH;

	my.group = 2;
	c_setminmax(me); 
	p_Battler[2] = me;  
	mtl_setup(0,1,0,0);
	ent_morph (my, p3.playermodel);

	// if necessary, adjust the bounding box to give the entity 'floor room' (see remarks) 
	// my.min_z *= 0.5;

	if(p3.active == FALSE) set(me,INVISIBLE);
	var speed_down = 0;   // downward speed by gravity
	var anim_percent = 0; // animation percentage
	VECTOR vFeet;
	vec_for_min(vFeet,me); // vFeet.z = distance from player origin to lowest vertex
while(1){


	while (p3_dead == FALSE){
wait(1);
		while(p3_Defend == FALSE && p3_Attack == FALSE && p3_Run == FALSE && p3_Item == FALSE && p3_Damaged == FALSE && p3_Anima == FALSE)     { 
			anim_percent += 6*time_step; 
			ent_animate(p_Battler[2],p3_fightIdle,anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);
			if(p3_dead == TRUE) break;
		}
		anim_percent = 0;
		while (p3_Run == TRUE){
			
			anim_percent += 5*time_step; 
			ent_animate(p_Battler[2],p3_fightRun,anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);     
		}
		anim_percent = 0;
		while (p3_Attack == TRUE){
			
			anim_percent += 3*time_step; 
			ent_animate(p_Battler[2],p3_fightAttack,anim_percent,0); // play the "stand" animation
			wait(1);     
		}
		while (p3_Defend == TRUE){
			
			anim_percent += 3*time_step; 
			ent_animate(p_Battler[2],p3_fightDefense,anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);
			
		}

		while(p3_Item == TRUE){
			anim_percent += 3*time_step; 
			ent_animate(p_Battler[2],p3_fightItem,anim_percent,0); // play the "stand" animation
			wait(1);	
		}



		while(p3_Damaged == TRUE){
			while(anim_percent < 100){
				anim_percent += 4*time_step;//3 
				ent_animate(p_Battler[2],p3_fightDamaged,anim_percent,0); // play the "stand" animation
				wait(1);	
			}
			anim_percent= 100;
			
			while (anim_percent> 0){
				
				anim_percent -= 4*time_step; 
				//ent_animate(p_Battler[0],"walkA",anim_percent,ANM_CYCLE); // play the "stand" animation
				ent_animate(p_Battler[2],p3_fightDamaged,anim_percent,0); // play the "stand" animation
				
				
				wait(1);     
			}
		}


		while(p3_Anima == TRUE){
			anim_percent += 2*time_step; 
			ent_animate(p_Battler[2],p3_fightAnima,anim_percent,0); // play the "stand" animation
			wait(1);	
		}



		

		while(p3_dead == TRUE){
			anim_percent += 2*time_step; 
			
			ent_animate(p_Battler[2],p3_fightDead,anim_percent,0); 
			wait(1);
			
			if(p3.weak == FALSE){
				anim_percent = 100;
				
				while(anim_percent> 0){

					anim_percent -= 2*time_step; 
					
					ent_animate(p_Battler[2],p3_fightDead,anim_percent,0); 
					wait(1);
				}
				
				p3_dead = FALSE;
				p3.weak = FALSE;
				break;
			}
			wait(1);
		}
		
	}
wait(1);
}
	
}





VECTOR e_1Y;
VECTOR e_1X;
PANEL* temp_pan;


action animated_Character(){
	set(me,PASSABLE);
	
	VECTOR temp_pos;
	var anim_percent;
	while(1){
		
		anim_percent += 4*time_step; 
		ent_animate(me,"idle",anim_percent,ANM_CYCLE); // play the "stand" animation
		wait(1);   
	}
}
bool entitySitting = TRUE;
bool entitySpeaking = FALSE;
bool entitySitUp = FALSE;
bool entityIdle = FALSE;
bool entityStaySpeak = FALSE;
STRING* whichAnimationToDo = "";
ENTITY* Celestial;
action sitting_Character(){
	set(me,PASSABLE);
	Celestial = me;
	VECTOR temp_pos;
	while(1){
		
		var anim_percent = 0;
		while(entitySitting == TRUE){
			
			anim_percent += 2*time_step; 
			ent_animate(me,"sitIdle",anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);
			
		}
		while(entitySpeaking == TRUE){
			anim_percent += 0.7*time_step; 
			ent_animate(me,"sitSpeak",anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);
		}
		var anim_percent = 0;
		while(entitySitUp == TRUE){
			anim_percent += 2*time_step; 
			ent_animate(me,"sitUp",anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);
		}
		var anim_percent = 0;
		while(entityIdle == TRUE){
			anim_percent += 0.7*time_step; 
			ent_animate(me,"idle",anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);
		}
		var anim_percent = 0;
		while(entityStaySpeak == TRUE){
			anim_percent += 1*time_step; 
			ent_animate(me,whichAnimationToDo,anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);
		}
		wait(1);
	} 

}


bool entitySittingS = TRUE;
bool entitySpeakingS = FALSE;
bool entitySitUpS = FALSE;
bool entityIdleS = FALSE;
bool entityStaySpeakS = FALSE;
STRING* whichAnimationToDoS = "";
ENTITY* CelestialS;
action sitting_CharacterS(){
	set(me,PASSABLE);
	CelestialS = me;
	VECTOR temp_pos;
	while(1){
		
		var anim_percent = 0;
		while(entitySittingS == TRUE){
			
			anim_percent += 2*time_step; 
			ent_animate(me,"sit",anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);
			
		}
		while(entitySpeakingS == TRUE){
			anim_percent += 0.7*time_step; 
			ent_animate(me,"sitSpeak",anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);
		}
		var anim_percent = 0;
		while(entitySitUpS == TRUE){
			anim_percent += 2*time_step; 
			ent_animate(me,"sitUp",anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);
		}
		var anim_percent = 0;
		while(entityIdleS == TRUE){
			anim_percent += 0.7*time_step; 
			ent_animate(me,"idle",anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);
		}
		var anim_percent = 0;
		while(entityStaySpeakS == TRUE){
			anim_percent += 1*time_step; 
			ent_animate(me,whichAnimationToDoS,anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);
		}
		wait(1);
	} 

}

action justStay(){
	set(me,PASSABLE);
	Celestial = me;
	VECTOR temp_pos;
	while(1){
		
		var anim_percent = 0;
		while(entitySittingS == TRUE){
			
			anim_percent += 3*time_step; 
			ent_animate(me,"idle",anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);
			
		}


	}
}
action justSit(){
	set(me,PASSABLE);

	VECTOR temp_pos;
	while(1){
		
		var anim_percent = 0;
		while(entitySittingS == TRUE){
			
			anim_percent += 1*time_step; 
			ent_animate(me,"sit",anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);
			
		}


	}
}
bool verwandel = FALSE;
ENTITY* charSecond;
action justStayS(){
	set(me,PASSABLE);
	set(me,INVISIBLE);
	charSecond = me;
	VECTOR temp_pos;
	while(1){
		
		var anim_percent = 0;
		while(1){
			if(verwandel == TRUE){
				verwandel = FALSE;
				anim_percent += 1*time_step; 
				ent_animate(me,"Back",anim_percent,ANM_CYCLE); // play the "stand" animation
				wait(1);
				
			}
		}

	}
}

action rotate_Object(){
	
	while(1){
		//my.tilt += 0.1;
		my.roll += 0.05;
		wait(1);
	}
}

STRING* e1_Idle_String = "";
STRING* e1_Run_String = "";
STRING* e1_Attack_String = "";
STRING* e1_Back_String = "";
STRING* e1_doSth_String = "";


action e1_BattlerA()
{ 
	my.emask = ENABLE_PUSH;

	my.group = 2;
	VECTOR temp_pos;
	e_Battler[0] = me;

	var speed_down = 0;   // downward speed by gravity
	var anim_percent = 0; // animation percentage
	VECTOR vFeet;
	vec_for_min(vFeet,me); // vFeet.z = distance from player origin to lowest vertex
	if(enemy_Battle[0].active == FALSE) set(me,INVISIBLE);
	ent_morph (my, enemy_Battle[0].enemymodel);
	vec_set(my.red,vector(255,255,255));
	my.lightrange = 250; 
	c_setminmax(me); 
	vec_scale(my.scale_x,1);
	mtl_setup(0,4,0,2);
	// get a unique entity number
	//vec_for_min(e_1X,me);

	

	var anim_percent;
	while (1)
	{  

		while(e1_Dead == FALSE && e1_Run == FALSE && e1_Attack == FALSE && e1_Back == FALSE && e1_doSth == FALSE){
			
			anim_percent += 2*time_step; 
			ent_animate(me,e1_Idle_String,anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);   
			
			var dist_down; 

			if (c_trace(my.x,vector(my.x,my.y,my.z-5000), IGNORE_ME | IGNORE_PASSABLE | USE_BOX) > 0)
			dist_down = my.z + vFeet.z - target.z; // get distance between player's feet and the ground
			else
			dist_down = 0;

			// apply gravity when the player is in the air

			if (dist_down > 0)  // above floor, fall down with increasing speed
			dist_down = clamp(dist_down,0,accelerate(speed_down,5,0.1));

			else                // on or below floor, set downward speed to zero
			speed_down = 0;
		}
		anim_percent = 0;
		while(e1_Run == TRUE){
			
			anim_percent += 5*time_step; 
			ent_animate(me,e1_Run_String,anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);
		}
		anim_percent = 0;
		while(e1_Back == TRUE){
			
			anim_percent += 5*time_step; 
			ent_animate(me,e1_Back_String,anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);
		}
		anim_percent = 0;
		while(e1_Attack == TRUE){
			
			anim_percent += 4*time_step; 
			ent_animate(me,e1_Attack_String,anim_percent,0); // play the "stand" animation
			wait(1);
		}
		anim_percent = 0;
		while(e1_doSth == TRUE){
			
			anim_percent += 0.5*time_step; 
			ent_animate(me,"anima",anim_percent,0); // play the "stand" animation
			wait(1);
		}
		
		

		wait(1);
	}               

	
	

	
}                











////////////////////////////////////////////////////////////////////////////////////////
action e2_BattlerA()
{
	my.emask = ENABLE_PUSH;

	my.group = 2;
	
	var speed_down = 0;   // downward speed by gravity
	var anim_percent = 0; // animation percentage
	VECTOR vFeet;
	vec_for_min(vFeet,me); // vFeet.z = distance from player origin to lowest vertex
	e_Battler[1] = me;
	mtl_setup(0,4,0,2);
	if(enemy_Battle[1].active == FALSE) set(me,INVISIBLE);
	ent_morph (my, enemy_Battle[1].enemymodel);
	vec_set(my.red,vector(255,255,255));
	my.lightrange = 250; 
	c_setminmax(me); 
	vec_scale(my.scale_x,1);
	//vec_for_min(e_1X,me);
	/*
	if(p1_Attack == TRUE){
		tunnel_create(e2_Battle.x);	
		//ent_create("explo+11.tga", e1_Battler, explosion);	
	}*/

	var anim_percent;
	while (1)
	{  
		
		while(e2_Dead == FALSE && e2_Run == FALSE && e2_Attack == FALSE){
			
			anim_percent += 2*time_step; 
			ent_animate(me,enemy_List[1].idle,anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);   
			
			var dist_down; 

			if (c_trace(my.x,vector(my.x,my.y,my.z-5000), IGNORE_ME | IGNORE_PASSABLE | USE_BOX) > 0)
			dist_down = my.z + vFeet.z - target.z; // get distance between player's feet and the ground
			else
			dist_down = 0;

			// apply gravity when the player is in the air

			if (dist_down > 0)  // above floor, fall down with increasing speed
			dist_down = clamp(dist_down,0,accelerate(speed_down,5,0.1));

			else                // on or below floor, set downward speed to zero
			speed_down = 0;
			
		}
		anim_percent = 0;
		while(e2_Run == TRUE){
			
			anim_percent += 12*time_step; 
			ent_animate(me,enemy_List[1].run,anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);
		}
		anim_percent = 0;
		while(e2_Attack == TRUE){
			
			anim_percent += 5*time_step; 
			ent_animate(me,enemy_List[1].attack,anim_percent,0); // play the "stand" animation
			wait(1);
		}

		wait(1);
	}          

	
}   


action e3_BattlerA()
{
	my.emask = ENABLE_PUSH;

	my.group = 2;
	
	var speed_down = 0;   // downward speed by gravity
	var anim_percent = 0; // animation percentage
	VECTOR vFeet;
	vec_for_min(vFeet,me); // vFeet.z = distance from player origin to lowest vertex
	e_Battler[2] = me;
	mtl_setup(0,4,0,2);
	if(enemy_Battle[2].active == FALSE) set(me,INVISIBLE);
	ent_morph (my, enemy_Battle[2].enemymodel);
	vec_set(my.red,vector(255,255,255));
	my.lightrange = 250; 
	c_setminmax(me); 
	vec_scale(my.scale_x,1);
	//vec_for_min(e_1X,me);
	/*
	if(p1_Attack == TRUE){
		tunnel_create(e2_Battle.x);	
		//ent_create("explo+11.tga", e1_Battler, explosion);	
	}*/

	var anim_percent;
	while (1)
	{  
		
		while(e3_Dead == FALSE && e3_Run == FALSE && e3_Attack == FALSE){
			
			anim_percent += 2*time_step; 
			ent_animate(me,enemy_List[2].idle,anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);   
			
			var dist_down; 

			if (c_trace(my.x,vector(my.x,my.y,my.z-5000), IGNORE_ME | IGNORE_PASSABLE | USE_BOX) > 0)
			dist_down = my.z + vFeet.z - target.z; // get distance between player's feet and the ground
			else
			dist_down = 0;

			// apply gravity when the player is in the air

			if (dist_down > 0)  // above floor, fall down with increasing speed
			dist_down = clamp(dist_down,0,accelerate(speed_down,5,0.1));

			else                // on or below floor, set downward speed to zero
			speed_down = 0;
			
		}
		anim_percent = 0;
		while(e3_Run == TRUE){
			
			anim_percent += 12*time_step; 
			ent_animate(me,enemy_List[2].run,anim_percent,ANM_CYCLE); // play the "stand" animation
			wait(1);
		}
		anim_percent = 0;
		while(e3_Attack == TRUE){
			
			anim_percent += 5*time_step; 
			ent_animate(me,enemy_List[2].attack,anim_percent,0); // play the "stand" animation
			wait(1);
		}

		wait(1);
	}        

	
}   







action background(){
	mtl_setup(0,37,0,2);
}
action background1(){
	mtl_setup(0,12,0,2);
}
////////////////////////////////////////////////////////////////////////////////////////

ENTITY* blinser;
action Blinzeln01()
{ 
	blinser = me;
	while(1){

		bmap_load(bmap_for_entity(blinser,3), "Models\\sol_eye.png", 1);
		wait(-0.2);
		bmap_load(bmap_for_entity(blinser,3), "Models\\sol_eye.004.png", 1);
		wait(-5.3);

	}  
	
}

bool p1_sprechen = FALSE;
bool p1_mad = FALSE;
bool p1_angry = FALSE;
bool p1_sad = FALSE;
bool p1_normal = FALSE;
ENTITY* p1_sprecher;
action p1Sprecher()
{ 
	p1_sprecher = me;
	while(1){
		if (p1_mad == TRUE)  	bmap_load(bmap_for_entity(p1_sprecher,3), "Models\\sol_eye.040.png", 1);
		if (p1_angry == TRUE)  	bmap_load(bmap_for_entity(p1_sprecher,3), "Models\\sol_eye.010.png", 1);
		if (p1_sad == TRUE) bmap_load(bmap_for_entity(p1_sprecher,3), "Models\\sol_eye.009.png", 1);
		if (p1_normal == TRUE) bmap_load(bmap_for_entity(p1_sprecher,3), "Models\\sol_eye.001.png", 1);


		wait(1);
	}  
	
}
