

function handle_animation(var animation_speed) 
{
	if(animation_speed <= 0)	animation_speed = 1; 
	if(my.animblend != blend && my.blendframe != nullframe) { my.animate2 = 0; my.animblend = blend; }
	if(my.animblend == blend) 
	{
		if		 (my.currentframe == stand)		ent_animate(my, player_Idle,    my.animate, ANM_CYCLE); 
		else if(my.currentframe == run)			ent_animate(my, player_Running,      my.animate, ANM_CYCLE);
		else if(my.currentframe == walk)			ent_animate(my, player_walk,     my.animate, ANM_CYCLE);
		else if(my.currentframe == jump)			ent_animate(my, "jump",     my.animate,0);
		else if(my.currentframe == attack_a)	ent_animate(my, "attack_a", my.animate,0);
		else if(my.currentframe == attack_b)	ent_animate(my, "attack_b", my.animate,0);
		else if(my.currentframe == attack_c)	ent_animate(my, "attack_c", my.animate,0);
		else if(my.currentframe == attack_d)	ent_animate(my, "attack_d", my.animate,0);
		else if(my.currentframe == attack_e)	ent_animate(my, "attack_e", my.animate,0);
		else if(my.currentframe == attack_f)	ent_animate(my, "attack_f", my.animate,0);
		if		 (my.blendframe == stand)		ent_blend("idle",0,my.animate2);
		else if(my.blendframe == run)			ent_blend("run",0,my.animate2);
		else if(my.blendframe == walk)		ent_blend("walk",0,my.animate2);
		else if(my.blendframe == jump)		ent_blend("jump",0,my.animate2);
		else if(my.blendframe == fall)		ent_blend("jump",60,my.animate2);
		else if(my.blendframe == attack_a)	ent_blend("attack_a",0,my.animate2);
		else if(my.blendframe == attack_b)	ent_blend("attack_b",0,my.animate2);
		else if(my.blendframe == attack_c)	ent_blend("attack_c",0,my.animate2);
		else if(my.blendframe == attack_d)	ent_blend("attack_d",0,my.animate2);
		else if(my.blendframe == attack_e)	ent_blend("attack_e",0,my.animate2);
		else if(my.blendframe == attack_f)	ent_blend("attack_f",0,my.animate2);
		my.animate2 += 45 * time_step;
		if(my.animate2 >= 100) 
		{
			my.animate = 0;
			my.animblend = my.blendframe;
			my.blendframe = nullframe;
		}
	}
	//
	switch(my.animblend)
	{

		
		case stand:
			ent_animate(my,player_Idle,my.animate,ANM_CYCLE);
			my.animate += 5 * animation_speed * time_step;
			my.animate %= 100;
			my.currentframe = stand;
			break;
		case run:
			ent_animate(my,player_Running,my.animate,ANM_CYCLE);
			my.animate += 8 * animation_speed * time_step;
			my.animate %= 100;
			my.currentframe = run;
			break;
		case walk:
			ent_animate(my,player_walk,my.animate,ANM_CYCLE);
			my.animate += 8 * animation_speed * time_step;
			my.animate %= 100;
			my.currentframe = walk;
			break;
		case jump:	//flow through to fall
		case fall:
			if(my.jumping_mode == 3) { my.animate = 60; }
			ent_animate(my,"jump",my.animate,0);
			my.animate += 10 * animation_speed * time_step;
			my.currentframe = jump;
			if(my.animate >= 60 && my.jumping_mode == 1)		my.jumping_mode = 2; 
			if(my.animate >= 100) 
			{
				ent_animate(my,"jump",100,0);
				my.animate = 100;
				my.blendframe = stand;
				if(my.moving == 1) 
				{
					if(key_shift == 1)	my.blendframe = walk;
					else						my.blendframe = run; 
				}
			}
			break;
		case attack_a:
			ent_animate(my,"attack_a",my.animate,0);
			my.animate += 20 * animation_speed * time_step;
			my.currentframe = attack_a;
			if(my.animate >= 100) 
			{
				ent_animate(my,"attack_a",100,0);
				my.animate = 100;
				my.blendframe = stand;
				if(my.moving == 1) 
				{
					if(key_shift == 1)		my.blendframe = walk;
					else							my.blendframe = run; 
				}
				if(combo_continue == 1) 
				{
					combo_continue = 0;
					my.blendframe = attack_b;
				} 
				else
					my.movement_mode = 0;
			}
			break;
		case attack_b:
			ent_animate(my,"attack_b",my.animate,0);
			my.animate += 15 * animation_speed * time_step;
			my.currentframe = attack_b;
			if(my.animate >= 100) 
			{
				ent_animate(my,"attack_b",100,0);
				my.animate = 100;
				my.blendframe = stand;
				if(my.moving == 1) 
				{
					if(key_shift == 1)		my.blendframe = walk;
					else							my.blendframe = run; 
				}
				if(combo_continue == 1) 
				{
					combo_continue = 0;
					my.blendframe = attack_c;
				}
				else
					my.movement_mode = 0;
			}
			break;
		case attack_c:
			ent_animate(my,"attack_c",my.animate,0);
			my.animate += 10 * animation_speed * time_step;
			my.currentframe = attack_c;
			if(my.animate >= 100) 
			{
				ent_animate(my,"attack_c",100,0);
				my.animate = 100;
				my.blendframe = stand;
				if(my.moving == 1) 
				{
					if(key_shift == 1)		my.blendframe = walk;
					else							my.blendframe = run; 
				}
				if(combo_continue == 1) 
				{
					my.jumping_mode = 10;
					my.force_z = 12;
					my.gravity = 4;
					combo_continue = 0;
					my.blendframe = attack_d;
				}
				else
					my.movement_mode = 0;
			}
			break;
		case attack_d:
			handle_sword_collision();
			ent_animate(my,"attack_d",my.animate,0);
			my.animate += 15 * animation_speed * time_step;
			my.currentframe = attack_d;
			if(my.animate >= 100) 
			{
				ent_animate(my,"attack_d",100,0);
				my.animate = 100;
				my.blendframe = stand;
				if(my.moving == 1) 
				{
					if(key_shift == 1)		my.blendframe = walk;
					else							my.blendframe = run; 
				}
				if(combo_continue == 1) 
				{
					combo_continue = 0;
					my.blendframe = attack_e;
				}
				else
					my.movement_mode = 0;
			}
			break;
		case attack_e:
			ent_animate(my,"attack_e",my.animate,0);
			my.animate += 15 * animation_speed * time_step;
			my.currentframe = attack_e;
			if(my.jumping_mode == 0 && my.animate >= 20 && my.animate < 60) 
			{
				my.gravity = 3;
				my.jumping_mode = 10;
				my.force_z = 15;
			}
			if(my.animate >= 100) 
			{
				ent_animate(my,"attack_e",100,0);
				my.animate = 100;
				my.blendframe = stand;
				if(my.moving == 1) 
				{
					if(key_shift == 1)		my.blendframe = walk;
					else							my.blendframe = run; 
				}
				if(combo_continue == 1) 
				{
					combo_continue = 0;
					my.blendframe = attack_f;
				}
				else
					my.movement_mode = 0;
			}
			break;
		case attack_f:
			ent_animate(my,"attack_f",my.animate,0);
			my.animate += 6 * animation_speed * time_step;
			my.currentframe = attack_f;
			if(my.jumping_mode == 0 && my.animate >= 40 && my.animate < 60) 
			{
				my.gravity = 6;
				my.jumping_mode = 10;
				my.force_z = 12;
			}
			if(my.animate >= 100) 
			{
				my.movement_mode = 0;
				ent_animate(my,"attack_f",100,0);
				my.animate = 100;
				my.blendframe = stand;
				if(my.moving == 1) 
				{
					if(key_shift == 1)		my.blendframe = walk;
					else							my.blendframe = run; 
				}
			}
			break;
	}
	if(my.animblend >= attack_a && my.animblend <= attack_f)		handle_sword_collision();
	if(my.animblend != blend && my.blendframe != nullframe) 		{ my.animate2 = 0; my.animblend = blend; }
}
